unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Neu1: TMenuItem;
    Beenden1: TMenuItem;
    Bearbeiten1: TMenuItem;
    Nurwaagrechtundsenkrecht1: TMenuItem;
    procedure ImageonMousedown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure ImageOnMousemove(Sender: TObject; Shift: TShiftState; X,
                               Y: Integer);
    procedure ImageOnMouseUp(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure Neu1Click(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Nurwaagrechtundsenkrecht1Click(Sender: TObject);
  private
    zeichne: boolean;
    x0, y0: integer;
    myimageArchiv:array of TImage;
    procedure ZeigeNurEines(nr: integer);
    procedure SchalteUm(Sender: TObject);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure UntermenuDazu(ZuVerlaengerndes: Tmenuitem; Beschriftung: string); //immer brauchbar
var Item: TMenuItem;
begin
  Item := TMenuItem.Create(Form1);
  Item.Caption := Beschriftung;
  Item.OnClick := Form1.schalteUm;
  item.Enabled := true;
  ZuVerlaengerndes.Add(Item);
end;

procedure TForm1.ZeigeNurEines(nr: integer);
    var k:integer;
begin
  for k := 0 to length(myimageArchiv) - 1 do
    if k = nr - 1 then Begin
      myimageArchiv[k].show;
      myimageArchiv[k].width := Clientwidth;
      myimageArchiv[k].height := clientheight;
    End else Begin
      myimageArchiv[k].hide;
      myImageArchiv[k].height := 0;
      myImageArchiv[k].width := 0; //sonst flackerts
    End;
end;

procedure TForm1.SchalteUm(Sender: Tobject);
  var nr :integer;
      s: string;
begin
  s := (sender as TMenuItem).caption;
  if pos('&',s) = 1 then s := copy(s,2,length(s) - 1);
  nr := StrToInt(s);
  ZeigeNurEines(nr);
End;

procedure TForm1.Neu1Click(Sender: TObject);
  var myimage: TImage;  //uses extctrls einfgen
      nr: integer;
begin
  form1.WindowState := wsmaximized;
  zeichne := false;
  myimage := Timage.create(application); //Damit beim Beenden automatisch free
  nr := MainMenu1.items[1].count + 1;
  UntermenuDazu(MainMenu1.Items[1],IntToStr(nr));
  setlength(myimageArchiv,nr);
  myimageArchiv[nr-1] := myimage;
  ZeigeNurEines(nr);
  with myimage do Begin
    parent := Form1;
    //Ereignisprozeduren werden zur Laufzeit zugewiesen
    //Diese mssen als Methoden von Form1 geschrieben werden
    onMousedown :=ImageonMousedown;
    onmousemove := ImageOnMousemove;
    onmouseup := ImageOnMouseUp;
    left := 0;
    top := 0; //height und with schon in ZeigeNurEines
    Canvas.Rectangle(0,0,width,height);
    show;
  End;
  caption:='Klicke mit der Maus und zeichne!'
end;

procedure TForm1.Schliessen1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.ImageonMousedown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with (sender as Timage).canvas do moveto(x,y);
  Zeichne := True;
  x0 := x;
  y0 := y;
end;

procedure TForm1.ImageOnMousemove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if zeichne then with (sender as Timage).canvas do Begin
    {Falls nicht gleich krumme Linien gezeichnet werden sollen
    if abs(x - x0) < 5 then x := x0;
    if abs(y - y0) < 5 then y := y0;}
    lineto(x,y);
    {x0 := x;
    y0 := y;}
  End;
end;

procedure TForm1.ImageOnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Zeichne := false;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  close
end;

procedure TForm1.Nurwaagrechtundsenkrecht1Click(Sender: TObject);
begin
   showmessage('Aufgabe:'#13#10+
               'Programmiere diesen Teil');
end;

end.
